#!/usr/bin/python3

import subprocess as s
import n4d.server.core as n4dcore
import n4d.responses
import dbus
import threading
import time

class CDC:
    def __init__(self):
        
        self.core=n4dcore.Core.get_core()
        self.systembus = dbus.SystemBus()
        systemd1 = self.systembus.get_object('org.freedesktop.systemd1','/org/freedesktop/systemd1')
        self.systemdmanager =  dbus.Interface(systemd1, 'org.freedesktop.systemd1.Manager')
   
    #def __init__

    def startup(self,options):
        t = threading.Thread(target=self._startup)
        t.daemon = True
        t.start()

    def _startup(self):
        try:
            if "ENABLE_CDC" in self.core.variables_manager.variables:
                self.core.delete_variable("ENABLE_CDC")
            for x in range(0,10):
                result = self.core.get_variable("ENABLE_CDC")
                if result['return'] is None:
                    time.sleep(1)
                elif result["return"]:
                    p = s.Popen(["cdccli","-e"],stdout=s.PIPE, stderr=s.PIPE)
                    p.communicate()
                    self.systemdmanager.ReloadOrRestartUnit('sssd.service','replace')
                    return n4d.responses.build_successful_call_response()
                else:
                    break
        except Exception:
            pass
        p = s.Popen(["cdccli","-d"],stdout=s.PIPE, stderr=s.PIPE)
        p.communicate()
        self.systemdmanager.ReloadOrRestartUnit('sssd.service','replace')

        #Old n4d: eturn [True,True]
        return n4d.responses.build_successful_call_response()
    #def startup(self):

#class CDC
